<?php
$ispconfig_config_file = '/usr/local/ispconfig/server/lib/config.inc.php';
$snappymail_user = 'www-data';
$snappymail_group = 'www-data';
$snappymail_dir = '/var/www/apps/webmail';
$snappymail_config_file = $snappymail_dir.'/data/_data_/_default_/configs/application.ini';
$snappymail_secrets_file = '/etc/th-snappymail.inc.php';
$debian_snappymail_secrets_file = '/usr/share/rainloop/data/_data_/_default_/configs/application.ini';
$snappymail_fail2ban_jail_file = '/etc/fail2ban/jail.d/snappymail.conf';
$snappymail_fail2ban_port = '8081';

// snappymail_dbpass & password_snappymail_crypted
if(file_exists($snappymail_secrets_file)){
	include($snappymail_secrets_file);
} else {
	$snappymail_dbpass = '';
	$password_snappymail_crypted = 'ddfbd38054c8c8bbc42a9e166ec1c98c';
	
	if(file_exists($debian_snappymail_secrets_file)){
		$old_config = parse_ini_file($debian_snappymail_secrets_file, true);
		
		if(!empty($old_config['contacts']['pdo_password'])){
			$snappymail_dbpass = $old_config['contacts']['pdo_password'];
		}
		if(!empty($old_config['security']['admin_password'])){
			$password_snappymail_crypted = $old_config['security']['admin_password'];
		}
	}

	if(empty($snappymail_dbpass)){
		// snappymail_dbpass
		exec('pwgen -snc '.rand(14,19).' 1', $output);
		$snappymail_dbpass = trim($output[0]);
		unset($output);
	}
	
	$snappymail_secrets = '<?php
$snappymail_dbpass = \''.$snappymail_dbpass.'\';
$password_snappymail_crypted = \''.$password_snappymail_crypted.'\';';

	file_put_contents($snappymail_secrets_file, $snappymail_secrets);
	chmod($snappymail_secrets_file, 0600);
	chown($snappymail_secrets_file, 'root');
	chgrp($snappymail_secrets_file, 'root');
}

if(file_exists($ispconfig_config_file)){
	$snappymail_user = 'ispapps';
	$snappymail_group = 'ispapps';
	include($ispconfig_config_file);
	
	if(isset($conf['cloud2_identifier']) && intval($conf['cloud2_identifier']) > 10001 && intval($conf['cloud2_identifier']) % 2 == 0){
		//$controlport = 3307;
		//$host = 'db.c'.$conf['cloud2_identifier'].'.'.$conf['cloud2_domain'];
		//$additional_safe_hosts .= ", '".$host."'";
		$snappymail_fail2ban_port = 'http,https';
	}
}

$trans = array(
	'{SNAPPYMAIL_DBPASS}' => $snappymail_dbpass,
	'{PASSWORD_SNAPPYMAIL_CRYPTED}' => $password_snappymail_crypted
);

// Datenbankversion auslesen
$last_line = system("mysql -V", $retval);

if(empty($retval)){
	$last_line = trim($last_line);
	$dbversion = '0.0';
	$dbflavour = 'mariadb';
	if(!preg_match('/MariaDB/i', $last_line)){
		$dbflavour = 'mysql';
	}
	if(preg_match('/Distrib (\d+\.\d+\.\d+)/i', $last_line, $matches)){
		$dbversion = $matches[1];
	}
	echo "Found database version ".$dbflavour." ".$dbversion.".\n";
} else {
	exit($retval);
}

// check if rainloop database exists
$result = system('mysql --defaults-file=/etc/mysql/debian.cnf -e "SHOW DATABASES LIKE \'rainloop\';"', $retval);
if(!empty($retval)) exit($retval);
if(empty($result) || empty(trim($result))){
	// create rainloop database
	echo "Creating database \"rainloop\"...\n";
	
	system('mysql --defaults-file=/etc/mysql/debian.cnf -e "CREATE DATABASE rainloop;SHOW DATABASES;"', $retval);
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	echo "Success!\n";
} else {
	echo "Database \"rainloop\" already exists.\n";
}

// check if mysql user exists
$result = system('mysql --defaults-file=/etc/mysql/debian.cnf -e "SELECT User FROM mysql.user WHERE User = \'rainloop\';"', $retval);
if(!empty($retval)) exit($retval);
if(empty($result) || empty(trim($result))){
	// create phpmyadmin DB user
	echo "Creating database user \"rainloop\"...\n";
	
	system('mysql --defaults-file=/etc/mysql/debian.cnf -e "CREATE USER \'rainloop\'@\'localhost\' IDENTIFIED BY \''.$snappymail_dbpass.'\';"', $retval);
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	system('mysql --defaults-file=/etc/mysql/debian.cnf -e "GRANT USAGE,SELECT,INSERT,UPDATE,DELETE,CREATE,DROP,REFERENCES,INDEX,ALTER,CREATE TEMPORARY TABLES,LOCK TABLES,EXECUTE,CREATE VIEW,SHOW VIEW,CREATE ROUTINE,ALTER ROUTINE,EVENT,TRIGGER ON rainloop.* TO \'rainloop\'@\'localhost\';"', $retval);
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	system('mysql --defaults-file=/etc/mysql/debian.cnf -e "FLUSH PRIVILEGES;"', $retval);
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	echo "Success!\n";
} else {
	echo "Database user \"rainloop\" already exists.\n";
}

// check if MySQL login works
exec('mysql -u rainloop -p'.escapeshellarg($snappymail_dbpass).' -e "quit" &> /dev/null', $output, $retval);
unset($output);
if(!empty($retval)){ // MySQL login does not work
	echo "MySQL login does not work, trying to reset password...\n";
	// see https://linuxize.com/post/how-to-change-mysql-user-password/
	if(($dbflavour == 'mariadb' && version_compare($dbversion, '10.1.20', '>=')) || ($dbflavour == 'mysql' && version_compare($dbversion, '5.7.6', '>='))) {
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "ALTER USER \'rainloop\'@\'localhost\' IDENTIFIED BY \''.$snappymail_dbpass.'\';"', $retval);
	} else {
		// SET PASSWORD FOR 'user-name'@'localhost' = PASSWORD('NEW_USER_PASSWORD');
		system('mysql --defaults-file=/etc/mysql/debian.cnf -e "SET PASSWORD FOR \'rainloop\'@\'localhost\' = PASSWORD(\''.$snappymail_dbpass.'\');"', $retval);
	}	
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	system('mysql --defaults-file=/etc/mysql/debian.cnf -e "FLUSH PRIVILEGES;"', $retval);
	if(!empty($retval)){
		echo "Failure!\n";
		exit($retval);
	}
	echo "Success!\n";
} else {
	echo "MySQL login successful!\n";
}

$snappymail_config = file_get_contents($snappymail_config_file);
$snappymail_config = strtr($snappymail_config, $trans);
file_put_contents($snappymail_config_file, $snappymail_config);
chmod($snappymail_config_file, 0640);
system('chown -R '.escapeshellarg($snappymail_user).':'.escapeshellarg($snappymail_group).' '.escapeshellarg($snappymail_dir), $retval);
if(!empty($retval)) exit($retval);

// fail2ban
$snappymail_fail2ban_jail_config = file_get_contents($snappymail_fail2ban_jail_file);
$snappymail_fail2ban_jail_config = preg_replace('/port = .+/im','port = '.$snappymail_fail2ban_port, $snappymail_fail2ban_jail_config);
file_put_contents($snappymail_fail2ban_jail_file, $snappymail_fail2ban_jail_config);

// self-destroy
unlink(__FILE__);
exit(0);